      program blue
!        use F90_UNIX_ENV, only : GETARG
        implicit none
        include 'mpif.h'
                                
        character*10 compname
        data compname / 'indigocomp' /
        character*8 rgnname
        data rgnname / 'indigoR1' /
        character*8 rgnname2
        data rgnname2 / 'indigoR2' /
        character*8 rgnname3
        data rgnname3 / 'indigoR3' /


        character*80 nameXJD
        character*80 option
        
        integer groupcomm, sts
        integer i, rank, ntask, XJD_id, icsts
        
        integer desc
        real A(4)
        integer region_set(2)
        integer indices1(4)
        integer indices2(2)

        integer bcast_recvtest(1)
        integer bcasttest(10)
        
!   initialize mpi
        print *, 'initialize mpi'
        call MPI_INIT(sts)
        call MPI_COMM_DUP(MPI_COMM_WORLD, groupcomm, sts)
        call MPI_COMM_RANK(groupcomm, rank, sts)
        call MPI_BARRIER(groupcomm, sts)
        call MPI_COMM_SIZE(groupcomm, ntask, sts)


!   get the second argument (the XJD file name) and broadcast it to all
!   other processes because fortran does not have standard mechanism
!   to handle the command-line argument list.
!   just assume that the first argument is -d . This example code does 
!   not care about the command-line option correctness.
        if (rank .EQ. 0) then
            call GETARG(1, option)
            call GETARG(2, nameXJD)

        end if

        call MPI_BCAST (nameXJD, 80, MPI_CHARACTER, 0, groupcomm, sts) 
        print *, nameXJD, rank
!        call TESTCALL(nameXJD, rank)

        print *, 'initialize ic'
        call IC_Initialize(compname, rank, nameXJD, XJD_id, icsts);

        print *, 'prepare data'
        call create_ttable(ntask, rank, A, desc) 

!   define a region consisting of one 4-element and one 2-element 
!   block for transfer region_set(1) and region_set(2) has id in parray
        print *, 'define regions'
        do i = 1, 4
            indices1(i) = i
        end do
        call IC_Create_enum_region(indices1, 4, region_set(1))    
        
        do i = 1, 2
           indices2(i) = i + 8
        end do
        call IC_Create_enum_region(indices2, 2, region_set(2))

        call IC_Register_region(XJD_id, region_set, 2, rgnname, desc, 
     &                          A, icsts)
     
        call IC_Commit_region(XJD_id, icsts)
        print *, icsts
        call IC_Import(XJD_id, rgnname, icsts)
        print *, icsts

        call printarray(A)


!   receive the broadcasted 1-cell array
        call IC_Recv_local(XJD_id, rgnname2, bcast_recvtest, 1, icsts);
        print *, 'Received Bcast Value : ' , bcast_recvtest(1);


!   broadcast 10-cell array   
        do i = 1, 10
            bcasttest(i) = i
        end do
        call IC_Bcast_local(XJD_id, rgnname3, bcasttest, 10, icsts);


!   clean up 
        print *, 'clean up'
        call IC_Free_region(region_set(2))
        call IC_Free_region(region_set(1))
        call IC_Free_desc(desc)
        call IC_Finalize(XJD_id, icsts);
        
        print *, 'finalize mpi'
        call MPI_BARRIER(groupcomm, sts)
        call MPI_COMM_FREE(groupcomm)
        call MPI_FINALIZE(sts)
      end
      
      subroutine printarray(A)
        implicit none
        real A(4)
        
        print *, A
      end

      subroutine create_ttable(p, r, A, desc)
        implicit none
        integer p, r, desc
        real A(4)
        integer globals(4), offsets(4), tasks(4)
        integer i
       
        do i = 1, 4
            globals(i) = 4*r + i
        end do
         
        do i = 1, 4
            offsets(i) = mod((i-1), p) + 1
            tasks(i) = (4*r + i - 1) / p
        end do

        print *, globals
        print *, offsets
        print *, tasks
        
        call IC_Create_ttable_desc(globals, offsets, tasks, 4, desc)
        
        do i = 1, 4
            A(i) = globals(i)
        end do
      end
      
