divert(-1)
define(`F90_HILEVEL_FUNC',`
#define IC_EXPORT_ARRAY_$2_HELPER_F77     F77_FUNC_(ic_export_array_$1_helper, IC_EXPORT_ARRAY_$2_HELPER)
#define IC_IMPORT_ARRAY_$2_HELPER_F77     F77_FUNC_(ic_import_array_$1_helper, IC_IMPORT_ARRAY_$2_HELPER)
#define IC_BCAST_LOCALARR_$2_HELPER_F77     F77_FUNC_(ic_bcast_localarr_$1_helper, IC_BCAST_LOCALARR_$2_HELPER)
#define IC_RECV_LOCALARR_$2_HELPER_F77     F77_FUNC_(ic_recv_localarr_$1_helper, IC_RECV_LOCALARR_$2_HELPER)
#define IC_DUMP_$2_ARRAY_INTERNALS_F77 F77_FUNC_(ic_dump_$1_arrayinternals, IC_DUMP_$2_ARRAY_INTERNALS)
#define IC_DUMP_$2_ARRAY_INFO_F77      F77_FUNC_(ic_dump_$1_array_info, IC_DUMP_$2_ARRAY_INFO)
#define ICXJD_REGISTER_ARRAY_$2_HELPER_F77     F77_FUNC_(icxjd_reg_array_$1_helper, IC_REG_ARRAY_$2_HELPER)
#define ICXJD_BC_LOCALARR_$1_HELPER_F77  F77_FUNC_(icxjd_bc_localarr_$1_helper, ICXJD_BC_LOCALARR_$2_HELPER)
#define ICXJD_R_LOCALARR_$1_HELPER_F77  F77_FUNC_(icxjd_r_localarr_$1_helper, ICXJD_R_LOCALARR_$2_HELPER)
'
)

define(`F90_LOLEVEL_FUNC',`
#define IC_SEND_$2_HELPER_F77     F77_FUNC_(ic_send_$1_helper, IC_SEND_$2_HELPER)
#define IC_RECV_$2_HELPER_F77     F77_FUNC_(ic_recv_$1_helper, IC_RECV_$2_HELPER)
#define IC_BCAST_LOCAL_$2_HELPER_F77     F77_FUNC_(ic_bcast_local_$1_helper, IC_BCAST_LOCAL_$2_HELPER)
#define IC_RECV_LOCAL_$2_HELPER_F77     F77_FUNC_(ic_recv_local_$1_helper, IC_RECV_LOCAL_$2_HELPER)
'
)

define(`IC_EXPORT_HELPER',`
void IC_EXPORT_ARRAY_$2_HELPER_F77(IC_EndPoint** o, const F90_$1Array** A, int* msgtag, int* status) {

#ifdef IC_DEBUG
  cout << "Info about the array being exported:\n";
  IC_DUMP_$2_ARRAY_INTERNALS_F77(A);
  cout << "exporting: Array contents:\n";
  PRINT$2ARRAY_F77(A);
#endif

 (*o)->exportArray(**A, *msgtag, *status);
}'
)

define(`IC_IMPORT_HELPER',`
void IC_IMPORT_ARRAY_$2_HELPER_F77(IC_EndPoint** o, const F90_$1Array** A, int* msgtag, int* status) {
  int i;
#ifdef IC_DEBUG
  cout << "Info about the array being imported:\n";
  IC_DUMP_$2_ARRAY_INTERNALS_F77(A);
  cout << "importing: Current array contents:\n";
  PRINT$2ARRAY_F77(A);
#endif
  
  (*o)->importArray(**A, *msgtag, *status);
}'
)


define(`IC_BCAST_LOCALARR_HELPER',`
void IC_BCAST_LOCALARR_$2_HELPER_F77(IC_EndPoint** o, const F90_$1Array** A, int* nelems, int* msgtag, int* status) {
  int i;
#ifdef IC_DEBUG
  cout << "Info about the array being broadcasted:\n";
  IC_DUMP_$2_ARRAY_INTERNALS_F77(A);
  cout << "broadcasting: Current array contents:\n";
  PRINT$2ARRAY_F77(A);
#endif
  
  (*o)->bcastLocalArray(**A, *nelems, *msgtag, *status);
}'
)


define(`IC_RECV_LOCALARR_HELPER',`
void IC_RECV_LOCALARR_$2_HELPER_F77(IC_EndPoint** o, const F90_$1Array** A, int* nelems, int* msgtag, int* status) {
  int i;
#ifdef IC_DEBUG
  cout << "Info about the array being received:\n";
  IC_DUMP_$2_ARRAY_INTERNALS_F77(A);
  cout << "receiving: Current array contents:\n";
  PRINT$2ARRAY_F77(A);
#endif
  
  (*o)->recvLocalArray(**A, *nelems, *msgtag, *status);
}'
)


define(`IC_IC_DUMP_INFO_HELPER',`
void IC_DUMP_$2_ARRAY_INTERNALS_F77(const F90_$1Array** A) {
  unsigned i;
  printf("rank %d\n",(*A)->rank);
  for (i=0;i<static_cast<unsigned>((*A)->rank);++i){
    printf("F90Array Structure: shape [%d] %d stride [%d] %d\n",i,(*A)->shape[i],i,(*A)->stride[i]);
  }
  printf("\n");
}'
)

define(`ICXJD_REGISTER_HELPER',`
void ICXJD_REGISTER_ARRAY_$2_HELPER_F77(IC_EndPointSet** epset, char* arrname, const F90_$1Array** A, int* status) {

#ifdef IC_DEBUG
  cout << "Info about the array being exported:\n";
  IC_DUMP_$2_ARRAY_INTERNALS_F77(A);
  cout << "registering: Array contents:\n";
  PRINT$2ARRAY_F77(A);
#endif
  
 (*epset)->registerArray(arrname, **A, *status);
}'
)


define(`ICXJD_BCAST_LOCALARR_HELPER',`
void ICXJD_BC_LOCALARR_$1_HELPER_F77(IC_EndPointSet** epset , char* arrname, const F90_$1Array** A, int* nelems, int* status) { 

#ifdef IC_DEBUG
  cout << "bcast local array (c-wrapper-helper.m4)" << endl;
#endif

  (*epset)->bcastLocalArray(arrname, **A, *nelems, *status);
}'
)

define(`ICXJD_RECV_LOCALARR_HELPER',`
void ICXJD_R_LOCALARR_$1_HELPER_F77(IC_EndPointSet** epset , char* arrname, const F90_$1Array** A, int* nelems, int* status) { 

#ifdef IC_DEBUG
  cout << "recv local array (c-wrapper-helper.m4)" << endl;
#endif

  (*epset)->recvLocalArray(arrname, **A, *nelems, *status);
}'
)


define(`IC_SEND_HELPER',`
void IC_SEND_$2_HELPER_F77(int* p, int* s, const F90_$1Array** A, int* tag, int* sts) {
  IC_Program* otherp;
  IC_Sched* sched;

  otherp = (IC_Program*)plookup(*p);
  sched = (IC_Sched*)plookup(*s);

  *sts = IC_Send_$1(otherp, sched, (*A)->base, *tag);
}'
)

define(`IC_RECV_HELPER',`
void IC_RECV_$2_HELPER_F77(int* p, int* s, const F90_$1Array** A, int* tag, int* sts) {
  IC_Program* otherp;
  IC_Sched* sched;

  otherp = (IC_Program*)plookup(*p);
  sched = (IC_Sched*)plookup(*s);

  *sts = IC_Recv_$1(otherp, sched, (*A)->base, *tag);
}'
)


define(`IC_BCAST_LOCAL_HELPER',`
void IC_BCAST_LOCAL_$2_HELPER_F77(int* p, const F90_$1Array** A, int* nelems, int* tag, int* sts) {
  IC_Program* otherp;

  otherp = (IC_Program*)plookup(*p);

  *sts = IC_Bcast_local_$1(otherp, (*A)->base, *nelems, *tag);
}'
)

define(`IC_RECV_LOCAL_HELPER',`
void IC_RECV_LOCAL_$2_HELPER_F77(int* p, const F90_$1Array** A, int* nelems, int* tag, int* sts) {
  IC_Program* otherp;

  otherp = (IC_Program*)plookup(*p);

  *sts = IC_Recv_local_$1(otherp, (*A)->base, *nelems, *tag);
}'
)

divert
#include <iostream>
#include <string.h>
#include "IC_EndPoint.h"
#include "IC_EndPointSet.h"
#include "c-wrapper.h"
#include "carray_descriptor.h"

using namespace std;

F90_HILEVEL_FUNC(int, INT)
F90_HILEVEL_FUNC(float, FLOAT)
F90_HILEVEL_FUNC(double, DOUBLE)

F90_LOLEVEL_FUNC(char, CHAR)
F90_LOLEVEL_FUNC(short, SHORT)
F90_LOLEVEL_FUNC(int, INT)
F90_LOLEVEL_FUNC(float, FLOAT)
F90_LOLEVEL_FUNC(double, DOUBLE)

extern "C" {
  IC_IC_DUMP_INFO_HELPER(int, INT)
  IC_EXPORT_HELPER(int, INT)
  IC_IMPORT_HELPER(int, INT)
  IC_BCAST_LOCALARR_HELPER(int, INT)
  IC_RECV_LOCALARR_HELPER(int, INT)

  IC_IC_DUMP_INFO_HELPER(float, FLOAT)
  IC_EXPORT_HELPER(float, FLOAT)
  IC_IMPORT_HELPER(float, FLOAT)
  IC_BCAST_LOCALARR_HELPER(float, FLOAT) 
  IC_RECV_LOCALARR_HELPER(float, FLOAT)

  IC_IC_DUMP_INFO_HELPER(double, DOUBLE)
  IC_EXPORT_HELPER(double, DOUBLE)
  IC_IMPORT_HELPER(double, DOUBLE)
  IC_BCAST_LOCALARR_HELPER(double, DOUBLE)
  IC_RECV_LOCALARR_HELPER(double, DOUBLE)

  ICXJD_REGISTER_HELPER(int, INT)
  ICXJD_REGISTER_HELPER(float, FLOAT)
  ICXJD_REGISTER_HELPER(double, DOUBLE)

  ICXJD_BCAST_LOCALARR_HELPER(int)
  ICXJD_BCAST_LOCALARR_HELPER(float)
  ICXJD_BCAST_LOCALARR_HELPER(double)

  ICXJD_RECV_LOCALARR_HELPER(int)
  ICXJD_RECV_LOCALARR_HELPER(float)
  ICXJD_RECV_LOCALARR_HELPER(double)


/* for F90 lowlevel API*/
  IC_SEND_HELPER(char, CHAR)
  IC_RECV_HELPER(char, CHAR)
  IC_BCAST_LOCAL_HELPER(char, CHAR)
  IC_RECV_LOCAL_HELPER(char, CHAR)

  IC_SEND_HELPER(short, SHORT)
  IC_RECV_HELPER(short, SHORT)
  IC_BCAST_LOCAL_HELPER(short, SHORT)
  IC_RECV_LOCAL_HELPER(short, SHORT)

  IC_SEND_HELPER(int, INT)
  IC_RECV_HELPER(int, INT)
  IC_BCAST_LOCAL_HELPER(int, INT)
  IC_RECV_LOCAL_HELPER(int, INT)

  IC_SEND_HELPER(float, FLOAT)
  IC_RECV_HELPER(float, FLOAT)
  IC_BCAST_LOCAL_HELPER(float, FLOAT)
  IC_RECV_LOCAL_HELPER(float, FLOAT)

  IC_SEND_HELPER(double, DOUBLE)
  IC_RECV_HELPER(double, DOUBLE)
  IC_BCAST_LOCAL_HELPER(double, DOUBLE)
  IC_RECV_LOCAL_HELPER(double, DOUBLE)
}
