changequote([<,>])

[<#include "move.h">]
[<#include "global.h">]
[<#include "error.h">]
[<#include "intercomm.h">]
[<#include <stdlib.h>>]
[<#include <stdio.h>>]
[<#include <pvm3.h>>]

define([<IC_SEND>], [<
int IC_Send_$1(IC_Program* to, IC_Sched* sched, $1* data, int tag) {
  int proc;
  OneSched_s *Osched; 
  int sendFlag;
  
  int i;

  setcall("IC_Send_$1");
  if (to == 0 || sched == NULL || data == 0) {
    errormsg("invalid parameters");
    return 0;
  }

 
#ifdef IC_DEBUG 
  fprintf(stderr, "nProc: %d, Size: %d\n", sched->nproc, *(sched->size));
#endif

  for (proc = 0; proc < sched->nproc; proc++) { 
    sendFlag = 0;
    Osched = sched->sched[proc];
    
    if (Osched != NULL) {
      sendFlag = 1;
      pvm_initsend(GlueEncoding);
    }

#ifdef IC_DEBUG   
    fprintf(stderr, "Proc: %d\n", proc);
#endif
 
    while (Osched != NULL) {
      pvm_pk$2(data+Osched->offset, Osched->size, 1);

#ifdef IC_DEBUG   
      fprintf(stderr, "Offset: %d, Size: %d\n", Osched->offset, Osched->size);
      for(i=0; i<Osched->size ; i++){
	fprintf(stderr, "%4.0f ", (float) *(data+Osched->offset+i));
      }
      fprintf(stderr, "\n");
#endif
 
      Osched = Osched->next;
    }     
    
    if (sendFlag == 1) {
      pvm_send(TidPgme((pgme_s*)to,proc), tag);
    }
  }
  
  return 0;
}
>])

define([<IC_RECV>], [<
int IC_Recv_$1(IC_Program* from, IC_Sched* sched, $1* data, int tag) {
  int proc;
  OneSched_s *Osched;
 
  int i;
 
  setcall("IC_Recv_$1");
  if (from == 0 || sched == NULL || data == 0) {
    errormsg("invalid parameters");
    return 0;
  }

#ifdef IC_DEBUG   
  fprintf(stderr, "nProc: %d, Size: %d\n", sched->nproc, *(sched->size));
#endif

  for (proc = 0; proc < sched->nproc; proc++) {       
    Osched = sched->sched[proc];
    if (Osched != NULL) {
      pvm_recv(TidPgme((pgme_s*)from,proc), tag);

#ifdef IC_DEBUG   
      fprintf(stderr, "Proc: %d\n", proc);
#endif

      while (Osched != NULL) {

#ifdef IC_DEBUG   
        fprintf(stderr, "Offset: %d, Size: %d\n", Osched->offset, Osched->size);
        for(i=0; i<Osched->size ; i++){
          fprintf(stderr, "%4.0f ", (float) *(data+Osched->offset+i));
        }
        fprintf(stderr, "\n");
#endif

	pvm_upk$2(data+Osched->offset, Osched->size, 1); 
        
#ifdef IC_DEBUG   
        fprintf(stderr, "Received data\n");
        for(i=0; i<Osched->size ; i++){
          fprintf(stderr, "%4f, ", *(data+Osched->offset+i));
        }
        fprintf(stderr, "\n");
#endif

	Osched = Osched->next;	    
      }
    }
  }
  
  return 0;
}
>])

IC_SEND(char, byte)
IC_SEND(short, short)
IC_SEND(int, int)
IC_SEND(float, float)
IC_SEND(double, double)
IC_RECV(char, byte)
IC_RECV(short, short)
IC_RECV(int, int)
IC_RECV(float, float)
IC_RECV(double, double)



define([<IC_BCAST_LOCAL>], [<
int IC_Bcast_local_$1(IC_Program* to, $1* data, int nelems, int tag) {
  setcall("IC_Bcast_local_$1");
	
  if (to == 0 || data == 0) {
    errormsg("invalid parameters");
    return -1;
  }

  return $2BcastOutBand((pgme_s*)to, data, nelems, tag); 
}
>])

IC_BCAST_LOCAL(char, c)
IC_BCAST_LOCAL(short, s)
IC_BCAST_LOCAL(int, i)
IC_BCAST_LOCAL(float, f)
IC_BCAST_LOCAL(double, d)


define([<IC_RECV_LOCAL>], [<
int IC_Recv_local_$1(IC_Program* from, $1* data, int nelems, int tag) {
  setcall("IC_Recv_local_$1");
	
  if (from == 0 || data == 0) {
    errormsg("invalid parameters");
    return -1;
  }

  return $2RecvOutBand((pgme_s*)from, data, nelems, tag); 
}
>])

IC_RECV_LOCAL(char, c)
IC_RECV_LOCAL(short, s)
IC_RECV_LOCAL(int, i)
IC_RECV_LOCAL(float, f)
IC_RECV_LOCAL(double, d)


[<
/*
 * Begin: Added by Tahsin Kurc
 *
 * The following functions are used to perform off-band communication 
 * between two programs.
 *
 */
int sBcastOutBand(pgme_s *to, short *data, int nelems, int tag)
{
  if (MyPosPgme(ic_this_program)==0) { /* do the broadcast to other program */
    pvm_initsend(PvmDataDefault);
    pvm_pkshort(data,nelems,1);
    pvm_bcast(to->name,tag);
  }
  
  /* syncronize all processors after send. */
  /*  pvm_barrier(ic_this_program->name,NumNodePgme(ic_this_program)); */
  return 1;
}

int iBcastOutBand(pgme_s *to, int *data, int nelems, int tag)
{
  if (MyPosPgme(ic_this_program)==0) { /* do the broadcast to other program */
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data,nelems,1);
    pvm_bcast(to->name,tag);
  }
  
  /* syncronize all processors after send. */
  /*  pvm_barrier(ic_this_program->name,NumNodePgme(ic_this_program)); */
  return 1;
}

int fBcastOutBand(pgme_s *to, float *data, int nelems, int tag)
{
  if (MyPosPgme(ic_this_program)==0) { /* do the broadcast to other program */
    pvm_initsend(PvmDataDefault);
    pvm_pkfloat(data,nelems,1);
    pvm_bcast(to->name,tag);
  }
  
  /* syncronize all processors after send. */
  /* pvm_barrier(ic_this_program->name,NumNodePgme(ic_this_program)); */
  return 1;
}

int dBcastOutBand(pgme_s *to, double *data, int nelems, int tag)
{
  if (MyPosPgme(ic_this_program)==0) { /* do the broadcast to other program */
    pvm_initsend(PvmDataDefault);
    pvm_pkdouble(data,nelems,1);
    pvm_bcast(to->name,tag);
  }
  
  /* syncronize all processors after send. */
  /* pvm_barrier(ic_this_program->name,NumNodePgme(ic_this_program)); */
  return 1;
}

int cBcastOutBand(pgme_s *to, char *data, int nelems, int tag)
{
  if (MyPosPgme(ic_this_program)==0) { /* do the broadcast to other program */
    pvm_initsend(PvmDataDefault);
    pvm_pkstr(data);
    pvm_bcast(to->name,tag);
  }
  
  /* syncronize all processors after send. */
  /* pvm_barrier(ic_this_program->name,NumNodePgme(ic_this_program)); */
  return 1;
} 

int bBcastOutBand(pgme_s *to, char *data, int nelems, int tag)
{
  if (MyPosPgme(ic_this_program)==0) { /* do the broadcast to other program */
    pvm_initsend(PvmDataDefault);
    pvm_pkbyte(data,nelems,1);
    pvm_bcast(to->name,tag);
  }
  
  /* syncronize all processors after send. */
  /* pvm_barrier(ic_this_program->name,NumNodePgme(ic_this_program)); */
  return 1;
}

/*
 * Implementation of recv operations is closely related to implementation 
 * of broadcast operations above.
 */
int sRecvOutBand(pgme_s *from, short *data, int nelems, int tag)
{
  int bufid;
  int recvtid;
  
  recvtid = -1;
  if (from!=NULL)
    recvtid = pvm_gettid(from->name,0);
  bufid = pvm_recv(recvtid,tag);
  pvm_upkshort(data,nelems,1);
  return 1;
}  

int iRecvOutBand(pgme_s *from, int *data, int nelems, int tag)
{
  int bufid;
  int recvtid;
  
  recvtid = -1;
  if (from!=NULL)
    recvtid = pvm_gettid(from->name,0);
  bufid = pvm_recv(recvtid,tag);
  pvm_upkint(data,nelems,1);
  return 1;
}  

int fRecvOutBand(pgme_s *from, float *data, int nelems, int tag)
{
  int bufid;
  int recvtid;
  
  recvtid = -1;
  if (from!=NULL)
    recvtid = pvm_gettid(from->name,0);
  bufid = pvm_recv(recvtid,tag);
  pvm_upkfloat(data,nelems,1);
  return 1;
}  

int dRecvOutBand(pgme_s *from, double *data, int nelems, int tag)
{
  int bufid;
  int recvtid;
  
  recvtid = -1;
  if (from!=NULL)
    recvtid = pvm_gettid(from->name,0);
  bufid = pvm_recv(recvtid,tag);
  pvm_upkdouble(data,nelems,1);
  return 1;
}  

int cRecvOutBand(pgme_s *from, char *data, int nelems, int tag)
{
  int bufid;
  int recvtid;
  
  recvtid = -1;
  if (from!=NULL)
    recvtid = pvm_gettid(from->name,0);
  bufid = pvm_recv(recvtid,tag);
  pvm_upkstr(data);
  return 1;
}  

int bRecvOutBand(pgme_s *from, char *data, int nelems, int tag)
{
  int bufid;
  int recvtid;
  
  recvtid = -1;
  if (from!=NULL)
    recvtid = pvm_gettid(from->name,0);
  bufid = pvm_recv(recvtid,tag);
  pvm_upkbyte(data,nelems,1);
  return 1;
}  

/*
 * End: Added by Tahsin Kurc
 */

int sDataMoveSend(pgme_s *to, sched_s *sched, short *tab, int tag)
{
  int proc;
  OneSched_s *Osched; 
  int sendFlag;
  
  if (sched == NULL) 
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) { 
    sendFlag = 0;
    Osched = sched->sched[proc];
    
    if (Osched != NULL) {
      sendFlag = 1;
      pvm_initsend(GlueEncoding);
    }
    
    while (Osched != NULL) {
      pvm_pkshort(tab+Osched->offset, Osched->size, 1);
      Osched = Osched->next;
    }     
    
    if (sendFlag == 1) {
      pvm_send(TidPgme(to,proc), tag);
    }
  }
  
  return 0;
}

int iDataMoveSend(pgme_s *to, sched_s *sched, int *tab, int tag)
{
  int proc;
  OneSched_s *Osched; 
  int sendFlag;
  
  if (sched == NULL) 
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) {
    sendFlag = 0;
    Osched = sched->sched[proc];

    if (Osched != NULL) {
      sendFlag = 1;
      pvm_initsend(GlueEncoding);
    }
    
    while (Osched != NULL) {
      pvm_pkint(tab+Osched->offset, Osched->size, 1);
      Osched = Osched->next;
    }     

    if (sendFlag == 1) {
      pvm_send(TidPgme(to,proc), tag);
    }
  }
  return 0;
}

int fDataMoveSend(pgme_s *to, sched_s *sched, float *tab, int tag)
{
  int proc;
  OneSched_s *Osched; 
  int sendFlag;

  if (sched == NULL) 
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) {
    sendFlag = 0;
    Osched = sched->sched[proc];

    if (Osched != NULL) {
      sendFlag = 1;
      pvm_initsend(GlueEncoding);
    }
    
    while (Osched != NULL) {
      pvm_pkfloat(tab+Osched->offset, Osched->size, 1);
      Osched = Osched->next;
    }     

    if (sendFlag == 1) {
      pvm_send(TidPgme(to,proc), tag);
    }
  }
  
  return 0;
}

int dDataMoveSend(pgme_s *to, sched_s *sched, double *tab, int tag)
{
  int proc;
  OneSched_s *Osched; 
  int sendFlag;
  
  if (sched==NULL) 
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) {
    sendFlag = 0;
    Osched = sched->sched[proc];

    if (Osched != NULL) {
      sendFlag = 1;
      pvm_initsend(GlueEncoding);
    }
    
    while (Osched != NULL) {
      pvm_pkdouble(tab+Osched->offset, Osched->size, 1); 	 
      Osched = Osched->next;
    }  
    
    if (sendFlag == 1) {
      pvm_send(TidPgme(to,proc), tag);
    }
  }

  return 0;
}

int sDataMoveRecv(pgme_s *from, sched_s *sched, short *tab, int tag)
{  
  int proc;
  OneSched_s *Osched;
  
  if (sched == NULL) 
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) {       
    Osched = sched->sched[proc];
    if (Osched != NULL) {
      pvm_recv(TidPgme(from,proc), tag);
      while (Osched != NULL) {
	pvm_upkshort(tab+Osched->offset, Osched->size, 1);
	Osched = Osched->next;
      }
    }
  }
  
  return 0;
}

int iDataMoveRecv(pgme_s *from, sched_s *sched, int *tab, int tag)
{  
  int proc;
  OneSched_s *Osched;
  
  if (sched == NULL) 
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) {       
    Osched = sched->sched[proc];
    if (Osched != NULL) {
      pvm_recv(TidPgme(from,proc), tag);
      while (Osched != NULL) {
	pvm_upkint(tab+Osched->offset, Osched->size, 1);
	Osched = Osched->next;
      }
    }
  }

  return 0;
}

int fDataMoveRecv(pgme_s *from, sched_s *sched, float *tab, int tag)
{  
  int proc;
  OneSched_s *Osched;

  if (sched == NULL) 
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) {       
    Osched = sched->sched[proc];
    if (Osched != NULL) {
      pvm_recv(TidPgme(from,proc), tag);
      while (Osched != NULL) {
	pvm_upkfloat(tab+Osched->offset, Osched->size, 1);
	Osched = Osched->next;
      }
    }
  }
  
  return 0;
}

int dDataMoveRecv(pgme_s *from, sched_s *sched, double *tab, int tag)
{  
  int proc;
  OneSched_s *Osched;
  
  if (sched == NULL)
    return 0;
  
  for (proc = 0; proc < sched->nproc; proc++) {       
    Osched = sched->sched[proc];
    if (Osched != NULL) {
      pvm_recv(TidPgme(from,proc), tag);
      while (Osched != NULL) {
	pvm_upkdouble(tab+Osched->offset, Osched->size, 1); 
	Osched = Osched->next;	    
      }
    }
  }
  
  return 0;
}
>]
