#include <iostream>
#include <assert.h>
#include "IC_Connection.h"

IC_Connection::IC_Connection(const char* connname, const char* portname){
  this->connname = connname;
  this->portname = portname;
  
  this->ep = NULL;
  this->tag = -1;
  this->sched = NULL;
  this->desc = NULL;
  this->rgn = NULL;
}

IC_Connection::~IC_Connection(void) {
  if(!strcmp(this->get_ctype().c_str(), "MxN")){ 
    free(this->get_sched());

    IC_Region** rgnset = (IC_Region**)this->get_rgn();
    /* because regionset has only one region in this case*/
    IC_Free_region(rgnset[0]);  
    free(rgnset);
    
    IC_Free_desc(this->get_desc());
  }
}

const char* IC_Connection::get_connname(void){
  return this->connname;
}

string IC_Connection::get_portname(){
  return this->portname;
}

IC_EndPoint* IC_Connection::get_ep(void){
  return this->ep;
}

void IC_Connection::set_ep(IC_EndPoint* ep){
  this->ep = ep;
}

int IC_Connection::get_tag(){
  return this->tag;
}

void IC_Connection::set_tag(int tag){
  this->tag = tag;
}

int IC_Connection::get_type(){
  return this->type;
}

void IC_Connection::set_type(int type){
  this->type = type;
}

string IC_Connection::get_ctype(){
  return this->ctype;
}

void IC_Connection::set_ctype(string ctype){
  this->ctype = ctype;
}

string IC_Connection::get_dtype(){
  return this->dtype;
}

void IC_Connection::set_dtype(string dtype){
  this->dtype = dtype;
}

IC_Region** IC_Connection::get_rgn(){
  return this->rgn;
}

void IC_Connection::set_rgn(IC_Region** rgn){
  this->rgn = rgn;
}

IC_Desc* IC_Connection::get_desc(){
  return this->desc;
}

void IC_Connection::set_desc(IC_Desc* desc){
  this->desc = desc;
}

IC_Sched* IC_Connection::get_sched(){
  return this->sched;
}

void IC_Connection::set_sched(IC_Sched* sched){
  this->sched = sched;
}


