/**
 * This is the class for public XJD-based high-level interface of InterComm.
 * @file IC_Port.h
 * @author Il-Chul Yoon
 *         University of Maryland, College Park
 */

#ifndef IC_CONNECTION_H
#define IC_CONNECTION_H

#include <stdio.h>
#include "IC_EndPoint.h"
#include <string>

using namespace std;

/*!
 This is the class for public high-level interface of InterComm.
*/
class IC_Connection {
  
public:

  IC_Connection(const char* connname, const char* portname);
  virtual ~IC_Connection();

private:
  const char* connname;
  string portname;

  IC_EndPoint* ep;
  int tag;
  int type; // as exporter = 0, as importer=1
  string ctype;
  string dtype;

  IC_Region** rgn;
  IC_Desc* desc;
  IC_Sched* sched;

public:
  const char* get_connname();
  string get_portname();

  IC_EndPoint* get_ep();
  void set_ep(IC_EndPoint* ep);

  int get_tag();
  void set_tag(int tag);

  int get_type();
  void set_type(int type);

  string get_ctype();
  void set_ctype(string ctype);

  string get_dtype();
  void set_dtype(string dtype);
  
  IC_Region** get_rgn();
  void set_rgn(IC_Region** rgn);

  IC_Desc* get_desc();
  void set_desc(IC_Desc* desc);

  IC_Sched* get_sched();
  void set_sched(IC_Sched* sched);
};

#endif


