c     
c     main
c     
      program main
      implicit none
      include 'ftest.h'
      
      character*4 groupname
      character*4 othername
      character*4 thirdname
      common /BLOCK1/ groupname, othername, thirdname

      integer this
      integer other
      integer third
      common /BLOCK2/ this, other, third

      integer r, info
      integer sz(RANK), desc

      integer A(DIMX*DIMY)
      integer decomp, region

      groupname = 'west'
      othername = 'east'
      thirdname = 'nort'

      call commonfstartup('ftest_west', r, info)
      if (info .EQ. 0) then
         stop
      end if
      
      if (r .EQ. 0) then
         print *, 'starting tests'
      end if

c     BDECOMP <-> BDECOMP
      if (r .EQ. 0) then
         print *, 'testing bdecomp <-> bdecomp transfers...'
      end if

      decomp = 1
      do while (decomp .LE. DESCS)
         call create_block_desc(decomp, r, sz, desc)
         if (desc .LT. 0) then
            goto 10
         end if

         region = 1
         do while (region .LE. XFERS)
            call initdarray(A, sz(1), sz(2), decomp, r)
            call senddregion(other, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if
            
            region = region + 1

            call initdarray(A, sz(1), sz(2), decomp, r)
            call recvdregion(other, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if
            call verifydrecv(other, A, sz(1), sz(2), r, decomp, region, 
     $           info)
            call pvmfallstatus(groupname, info, decomp*10+region)
            if (r .EQ. 0) then
               if (info .EQ. 0) then
                  print *, 'test', decomp, '.', region, ' failed'
               else
                  print *, 'test', decomp, '.', region, ' succeeded'
               end if               
            end if
            if (info .EQ. 0) then
               call printfxfer(region)
               call printfarray(A, sz(1), sz(2))
            end if
            
            region = region + 1
         end do
         
         call ic_free_desc(desc)
         decomp = decomp + 2
      end do      

c     BDECOMP <-> TTABLE 
      if (r .EQ. 0) then
         print *, 'testing bdecomp <-> ttable transfers...'
      end if

      decomp = 1
      do while (decomp .LE. DESCS)
         call create_block_desc(decomp, r, sz, desc)
         if (desc .LT. 0) then
            goto 10
         end if

         region = 1
         do while (region .LE. XFERS)
            call initdarray(A, sz(1), sz(2), decomp, r)
            call senddregion(third, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if
            
            region = region + 1

            call initdarray(A, sz(1), sz(2), decomp, r)
            call recvdregion(third, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if
            call verifydrecv(third, A, sz(1), sz(2), r, decomp, region, 
     $           info)
            call pvmfallstatus(groupname, info, decomp*10+region)
            if (r .EQ. 0) then
               if (info .EQ. 0) then
                  print *, 'test', decomp, '.', region, ' failed'
               else
                  print *, 'test', decomp, '.', region, ' succeeded'
               end if               
            end if
            if (info .EQ. 0) then
               call printfxfer(region)
               call printfarray(A, sz(1), sz(2))
            end if
            
            region = region + 1
         end do
         
         call ic_free_desc(desc)
         decomp = decomp + 2
      end do      

 10   continue
    
c     clean up
      call ic_free_program(third)
      call ic_free_program(other)
      call ic_quit(this)

      call pvmfbarrier('ftest_west', TASKS, info)
      call pvmfexit(info)

      if (r .EQ. 0) then
         print *, 'tests complete'
      end if
      end
