! program to test XJD-based high-level Intercomm interface
! Il-Chul Yoon : 01/11/2006
! Modified by Norman Lo: 04/15/2006
program intercomm_test

! using InterComm
  use intercomm_interface
  use array_printing

  implicit none

! array and variable declarations
  integer, dimension (10,10) :: INTEGERS
  integer :: i, j, ic_err
  integer broad(10)


! declaring InterComm endpointset object
  type(ic_obj) :: epset 

! initialize arrays
  do i = 1, 10
    do j = 1, 10
      INTEGERS(i,j) = (10*(i-1)+(j-1))
    end do
  end do

! creating communication endpoint set
  call ic_endpointset_constructor(epset,'multif90.xjd'//CHAR(0),'export'//CHAR(0),ic_err);


! testing if communication array is in a sane state
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_endpointset_constructor'//CHAR(0),ic_err)
    stop
  end if

! Broadcasting
  do i = 1,10
    broad(i) = i*5
  end do

  call ic_bcast_local_array(epset, 'exportrng1'//CHAR(0), broad, 10, ic_err)
  print *, "lexample.f90 >> Broadcasting successfully"

  call printArray(INTEGERS)

  call ic_register_array(epset, 'exportrng2'//CHAR(0), INTEGERS, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_register_array'//CHAR(0), ic_err)
    stop
  end if

  call ic_commit_arrays(epset, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_commit_arrays'//CHAR(0), ic_err)
    stop
  end if

  call ic_export_array(epset, 'exportrng2'//CHAR(0), ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_export_array'//CHAR(0), ic_err)
    stop
  end if

  call ic_endpointset_destructor(epset);
  print *,"done"

end program intercomm_test
