! program to test XJD-based high-level Intercomm interface
! Henrique - 9/3/2003
! Modified by Norman Lo: 04/15/2006
program intercomm_test

  use intercomm_interface
  use array_descriptor
  use array_printing

  implicit none

  integer, dimension (10,10) :: INTEGERS
  integer :: i, j, ic_err
  integer broad(10)
  integer test
  data test / 1 /

  type(ic_obj) :: epset
  type(arraydesc) :: INTEGERSDesc

  ! initialize array
  do i = 1, 10
    do j = 1, 10
      INTEGERS(i,j) = -1000
    end do
  end do

! creating communication endpoint set
  call ic_endpointset_constructor(epset,'multif90.xjd'//CHAR(0),'import2'//CHAR(0),ic_err);

! testing if communication array is in a sane state
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_endpointset_constructor'//CHAR(0),ic_err)
    stop
  end if

! Receiving broadcast
  call ic_recv_local_array(epset, 'import2rng1'//CHAR(0), broad, 10, ic_err)

  do i=1,10
    if (broad(i) /= i*5) then
       test = 0
    end if
  end do

  if (test == 1) then
    print *, "import2 >> Received broadcast successfully"
  else if (test == 0) then
    print *, "import2 >> Received broadcast FAILED"
  end if

  call ic_register_array(epset, 'import2rng2'//CHAR(0), INTEGERS, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_register_array'//CHAR(0), ic_err)
    stop
  end if

  call ic_commit_arrays(epset, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_commit_arrays'//CHAR(0), ic_err)
    stop
  end if

  call ic_import_array(epset, 'import2rng2'//CHAR(0), ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_import_array'//CHAR(0), ic_err)
    stop
  end if

  call printArray(INTEGERS)

  print *,"==============import2============="

  call ic_endpointset_destructor(epset);
  print *,"done"
end program intercomm_test
